{% extends 'component/list_component.html.twig' %}

{% block tableHeader %}
    <th class="mdc-data-table__header-cell pe-0 ps-2" role="columnheader" scope="col"></th>
    <th class="mdc-data-table__header-cell pe-0" role="columnheader" scope="col"></th>
    <th class="mdc-data-table__header-cell pe-0" role="columnheader" scope="col"></th>

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Gesuch',
        'columnId': 'gesuch',
        'ariaLabelId': 'looking-for-property-request-title',
        'ariaLabelName': 'Looking For Property Request Title'
    } only %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Gesucht von',
        'columnId': 'gesucht_von',
        'ariaLabelId': 'searched-by-person',
        'ariaLabelName': 'Searched By Person'
    } only %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Nutzung',
        'columnId': 'nutzung',
        'ariaLabelId': 'usage',
        'ariaLabelName': 'Usage'
    } only %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Flächenbedarf',
        'columnId': 'flaechenbedarf',
        'ariaLabelId': 'space-requirement',
        'ariaLabelName': 'Space Requirement'
    } only %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Matching am',
        'columnId': 'matching_am',
        'ariaLabelId': 'matching-at',
        'ariaLabelName': 'Matching At'
    } only %}

    {% include 'component/list_component/columnheader_component.html.twig' with {
        'sortable': sortable,
        'label': 'Status',
        'columnId': 'status',
        'ariaLabelId': 'status',
        'ariaLabelName': 'Status'
    } only %}
{% endblock %}

{% block tableContent %}
    {% set exposeForwarding = listItem.fetchExposeForwarding() %}
    {% set matchingResponse = listItem.fetchMatchingResponse() %}

    <td class="mdc-data-table__cell pe-0 ps-2">
        {% if exposeForwarding == null and listItem.getLookingForPropertyRequest.getPerson().getAccountUser() != null %}
            {% if is_granted('ROLE_USER') == true %}
                <a href="{{ path('company_location_management_matching_object_expose_forwarding_for_looking_for_property_request', {'matchingResultId': listItem.getId()}) }}" class="material-icons mdc-icon-button mdc-card__action mdc-card__action--icon text-secondary mdc-tooltip-anchor" aria-describedby="looking-for-property-request-matching-{{ listItem.getId() }}-send-mdc-tooltip">
                    <div class="mdc-icon-button__ripple"></div>
                    send
                </a>
                <div id="looking-for-property-request-matching-{{ listItem.getId() }}-send-mdc-tooltip" class="mdc-tooltip" role="tooltip" aria-hidden="true">
                    <div class="mdc-tooltip__surface mdc-tooltip__surface-animation" >Objekt an Suchenden weiterleiten</div>
                </div>
            {% endif %}
        {% elseif exposeForwarding != null %}
            <span class="material-icons mdc-card__action--icon text-disabled mdc-tooltip-anchor" aria-describedby="looking-for-property-request-matching-{{ listItem.getId() }}-send-mdc-tooltip">
                send
            </span>
            <div id="looking-for-property-request-matching-{{ listItem.getId() }}-send-mdc-tooltip" class="mdc-tooltip tooltip-longtext" role="tooltip" aria-hidden="true">
                <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">Das Objekt-Kurzexposé wurde bereits an den Suchenden weitergeleitet.</div>
            </div>
        {% else %}
            <span class="material-icons mdc-card__action--icon text-disabled mdc-tooltip-anchor" aria-describedby="looking-for-property-request-matching-{{ listItem.getId() }}-send-mdc-tooltip">
                send
            </span>
            <div id="looking-for-property-request-matching-{{ listItem.getId() }}-send-mdc-tooltip" class="mdc-tooltip tooltip-longtext" role="tooltip" aria-hidden="true">
                <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">Der Suchende hat bislang keinen eigenen Account auf LeAn®. Eine datenschutzkonforme Weiterleitung ist daher nicht möglich. Sie können alternativ das PDF-Kurzexposé über den 3-Punkte-Button oben rechts herunterladen, dem Suchenden per E-Mail senden und den Status über den 3-Punkte-Button in dieser Zeile manuell auf weitergeleitet setzen.</div>
            </div>
        {% endif %}
    </td>
    <td class="mdc-data-table__cell pe-0 ps-0">
        {% set contextMenuListItems = [
            {
                'label': 'zum Ansiedlungsgesuch',
                'url': path('company_location_management_looking_for_property_request_edit', {'id': listItem.getLookingForPropertyRequest().getId()}),
                'icon': 'search'
            },
        ] %}

        {% if is_granted('view', listItem.getLookingForPropertyRequest().getPerson()) == true %}
            {% set contextMenuListItems = contextMenuListItems|merge([
                {
                    'label': 'zum Suchenden',
                    'url': path('person_management_person_base_data', {'personId': listItem.getLookingForPropertyRequest().getPerson().getId()}),
                    'icon': 'person',
                },
            ]) %}
        {% endif %}

        {% if is_granted('ROLE_USER') == true %}
            {% if exposeForwarding == null and matchingResponse == null %}
                {% set contextMenuListItems = contextMenuListItems|merge([
                    {
                        'label': 'als »irrelevant« markieren',
                        'url': path('company_location_management_matching_looking_for_property_request_matching_response', {'matchingResultId': listItem.getId(), 'response': constant('App\\Domain\\Entity\\Matching\\Response::DISMISS').value}),
                        'icon': 'do_not_disturb_alt'
                    },
                ]) %}
            {% endif %}

            {% if exposeForwarding == null and listItem.getLookingForPropertyRequest.getPerson().getAccountUser() == null %}
                {% set contextMenuListItems = contextMenuListItems|merge([
                    {
                        'label': 'als »weitergeleitet« markieren',
                        'url': path('company_location_management_matching_object_mark_looking_for_property_request_as_forwarded', {'matchingResultId': listItem.getId()}),
                        'icon': 'send'
                    },
                ]) %}
            {% endif %}

            {% if exposeForwarding != null %}
                {% set listItemReject = {
                    'label': 'Auf »abgelehnt« setzen',
                    'url': path('company_location_management_matching_expose_forwarding_reject', {'matchingResultId': listItem.getId()}),
                    'icon': 'thumb_down'
                } %}

                {% set listItemEstablishContact = {
                    'label': 'Auf »Kontakt aufgenommen« setzen',
                    'url': path('company_location_management_matching_expose_forwarding_set_forwarding_response', {'matchingResultId': listItem.getId(), 'forwardingResponse': constant('App\\Domain\\Entity\\ForwardingResponse::CONTACT_ESTABLISHED').value}),
                    'icon': 'group'
                } %}

                {% set listItemContractConcluded = {
                    'label': 'Auf »Vertrag geschlossen« setzen',
                    'url': path('company_location_management_matching_expose_forwarding_set_forwarding_response', {'matchingResultId': listItem.getId(), 'forwardingResponse': constant('App\\Domain\\Entity\\ForwardingResponse::CONTRACT_CONCLUDED').value}),
                    'icon': 'receipt_long'
                } %}

                {% if exposeForwarding.getForwardingResponse() == null %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemReject, listItemEstablishContact, listItemContractConcluded]) %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'REJECTED' %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemEstablishContact, listItemContractConcluded]) %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'CONTACT_ESTABLISHED' %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemReject, listItemContractConcluded]) %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'CONTRACT_CONCLUDED' %}
                    {% set contextMenuListItems = contextMenuListItems|merge([listItemReject, listItemEstablishContact]) %}
                {% endif %}
            {% endif %}
        {% endif %}

        {% include 'component/mdc_context_menu_component.html.twig' with {
            'id': 'matching_result_' ~ listItem.getId(),
            'listItems': contextMenuListItems
        } only %}
    </td>
    <td class="mdc-data-table__cell pe-0 ps-0">
        <button class="material-icons mdc-icon-button mdc-card__action mdc-card__action--icon text-secondary mdc-tooltip-anchor" data-coreui-toggle="modal" data-coreui-target="#matching-result-{{ listItem.getId() }}" aria-describedby="looking-for-property-request-matching-{{ listItem.getId() }}-evaluation-mdc-tooltip">
            <div class="mdc-icon-button__ripple"></div>
            info_outline
        </button>
        <div id="looking-for-property-request-matching-{{ listItem.getId() }}-evaluation-mdc-tooltip" class="mdc-tooltip" role="tooltip" aria-hidden="true">
            <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">Details zur Bewertung einsehen.</div>
        </div>
    </td>
    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">{{ listItem.getLookingForPropertyRequest.getTitle() }}</td>
    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">
        {% if is_granted('view', listItem.getLookingForPropertyRequest().getPerson()) == true %}
            {{ listItem.getLookingForPropertyRequest.getPerson().buildShortDisplayName() }}
        {% endif %}
    </td>
    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">
        {% if listItem.getLookingForPropertyRequest.getPropertyRequirement().getIndustryClassification().getName()|length > 33 %}
            <span class="mdc-tooltip-anchor" aria-describedby="looking-for-property-request-matching-{{ listItem.getId() }}-industryClassification-mdc-tooltip">{{ listItem.getLookingForPropertyRequest.getPropertyRequirement().getIndustryClassification().getName()|slice(0,30) }}...</span>
            <div id="looking-for-property-request-matching-{{ listItem.getId() }}-industryClassification-mdc-tooltip" class="mdc-tooltip tooltip-longtext" role="tooltip" aria-hidden="true">
                <div class="mdc-tooltip__surface mdc-tooltip__surface-animation">
                    {{ listItem.getLookingForPropertyRequest.getPropertyRequirement().getIndustryClassification().getName() }}
                </div>
            </div>
        {% else %}
            {{ listItem.getLookingForPropertyRequest.getPropertyRequirement().getIndustryClassification().getName() }}
        {% endif %}
    </td>
    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">
        {% if listItem.getLookingForPropertyRequest().getPropertyRequirement().getPropertyValueRangeRequirement().getTotalSpace().getMinimumValue() is not null %}
            {{ listItem.getLookingForPropertyRequest().getPropertyRequirement().getPropertyValueRangeRequirement().getTotalSpace().getMinimumValue()|number_format(0, ',', '.') }} m&sup2;
        {% endif %}
        bis
        {{ listItem.getLookingForPropertyRequest().getPropertyRequirement().getPropertyValueRangeRequirement().getTotalSpace().getMaximumValue()|number_format(0, ',', '.') }} m&sup2;
    </td>

    <td class="mdc-data-table__cell{% if matchingResponse != null %} text-light{% endif %}">{{ listItem.getCreatedAt().format('d.m.Y') }}<br>{{ listItem.getCreatedAt().format('H:i') }} Uhr</td>
    <td class="mdc-data-table__cell">
        {% if matchingResponse != null %}
            <span class="text-danger">als irrelevant markiert</span>
        {% elseif exposeForwarding == null %}
            <span class="text-info">neu gefunden</span>
        {% else %}
            <span class=" text-info">weitergeleitet am {{ exposeForwarding.getCreatedAt().format('d.m.Y, H:i') }} Uhr</span><br>
            {% if exposeForwarding.getForwardingResponse() != null %}
                {% if exposeForwarding.getForwardingResponse().name == 'REJECTED' %}
                    <span class="text-danger">{{ exposeForwarding.getForwardingResponse().getName() }} {% if exposeForwarding.getUpdatedAt() != null %}am {{ exposeForwarding.getUpdatedAt().format('d.m.Y, H:i') }}{% endif %}</span>
                    {% if exposeForwarding.getRejectReason() is not empty %}
                        <i class="mdc-icon ms-0 pt-1 mdc-tooltip-anchor align-middle" aria-describedby="looking-for-property-request-matching-{{ listItem.getId() }}-rejectReason-mdc-tooltip">
                            <i class="material-icons" style="font-size:16px;">help_outline</i>
                        </i>
                        <div id="looking-for-property-request-matching-{{ listItem.getId() }}-rejectReason-mdc-tooltip" class="mdc-tooltip tooltip-longtext" role="tooltip" aria-hidden="true">
                            <div class="mdc-tooltip__surface mdc-tooltip__surface-animation" >{{ exposeForwarding.getRejectReason() }}</div>
                        </div>
                    {% endif %}
                {% elseif exposeForwarding.getForwardingResponse().name == 'PUT_BACK'  %}
                    <span class="text-warning">
                        {{ exposeForwarding.getForwardingResponse().getName() }}
                        {% if exposeForwarding.getUpdatedAt() != null %}am {{ exposeForwarding.getUpdatedAt().format('d.m.Y, H:i') }}{% endif %}
                    </span>
                {% else %}
                    <span class="text-success">
                        {{ exposeForwarding.getForwardingResponse().getName() }}
                        {% if exposeForwarding.getUpdatedAt() != null %}am {{ exposeForwarding.getUpdatedAt().format('d.m.Y, H:i') }}{% endif %}
                    </span>
                {% endif %}
            {% endif %}
        {% endif %}
    </td>
{% endblock %}
